﻿Type=StaticCode
Version=3.82
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Public debugMode As Boolean
	
	Public ConfigFile As String = "autostart.config"
	Public ConfigMap As Map
	Public AppsFile As String = "autostart.apps"
	Public AppsMap As Map
	Public filepath As String = File.DirInternal
	
	Public autoStartCheckFile As String = "autostart.start"
	
	
	Public SHOW_ABOUT As Boolean = False
	Public SHOW_HOWTO As Boolean = False
	
	Public pm As PackageManager
	
	Private su As StringUtils

End Sub



Public Sub ReturnBoolFromStr(s As String) As Boolean
	Select Case s
		Case "y","Y","1","-1"
			Return True
		Case Else 
			Return False
	End Select
End Sub


Public Sub ReturnStrFromBool(b As Boolean) As String
	If b Then Return "y"
	Return "n"
End Sub





#Region APP_AUTO_START
	
Public Sub SetAutoStartAppOn(turnON As Boolean)	
	'--- you need the svrAutoStart service for this
	'--- function to be of any use
	If turnON Then
		If Not (File.Exists(File.DirInternal,autoStartCheckFile)) Then 
			File.WriteString(File.DirInternal,autoStartCheckFile,"on")
		End If
	Else
		If File.Exists(File.DirInternal,autoStartCheckFile) Then 
			File.Delete(File.DirInternal,autoStartCheckFile)
		End If
	End If
End Sub

Public Sub GetAutoStartAppOn() As Boolean
	If File.Exists(File.DirInternal,autoStartCheckFile) Then 
		Return True
	Else
		Return False
	End If
End Sub

#End Region



#Region FONT_SIZES
Private Sub CheckSize(size As Float, MultipleLines As Boolean, mLbl As Label) As Boolean
	'--- returns true if the size is too large
	'--- called from setText
	Dim cvs As Canvas ,  bmp As Bitmap
	bmp.InitializeMutable(1%x,1%y)
	cvs.Initialize2(bmp)
	mLbl.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	Else
		Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, size) > mLbl.Width OR _
	    	   su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	End If
End Sub
'

Public Sub SetText(value As String, mLbl As Label)
	Dim HighValue As Float  = 2
	Dim LowValue As Float = 1
	Dim CurrentValue As Float

	mLbl.Text = value
	Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
	'need to set actual start values so find Gross Start/Stop values
	'first is linear Growth with some arbitrary 'large' value 'going with 30
	'this can be fine tuned based on size of the display that you are aiming for/have available vs size of your CustomViews

	Do While Not(CheckSize(HighValue, multipleLines,mLbl))
		LowValue = HighValue
		HighValue = HighValue + 30
	Loop

	CurrentValue = (HighValue + LowValue)/2
	'
	'initial sizes set, now for binary approach
	'
	'adjust this to taste.  I like it at 1, and I think it looks very nice... can go a little larger for even faster times
	'smaller for closer hit to actual optimum, but sacrificing a little speed
	'
	Dim ToleranceValue As Float = .5
	'ToleranceValue = 1

	Dim currentResult As Boolean
	Do While (CurrentValue - LowValue) > ToleranceValue OR (HighValue - CurrentValue) > ToleranceValue 
		
		currentResult = CheckSize(CurrentValue, multipleLines,mLbl)
		
		If currentResult Then 'this means currentvalue is too large
			HighValue = CurrentValue
		Else 'currentValue is too small
			LowValue = CurrentValue
		End If
		CurrentValue = (HighValue + LowValue) / 2
	Loop
	Dim offset As Int = 0
	mLbl.TextSize = ((CurrentValue - ToleranceValue) + offset)
	'debugLog("size:"& mLbl.TextSize)
End Sub

#End Region



Public Sub LoadTimeMap() As Map

	Dim map1 As Map
	map1.Initialize
	map1.Clear
	map1.Put("0","0 Sec")
	map1.Put("1","10 Sec")
	map1.Put("2","15 Sec")
	map1.Put("3","30 Sec")
	map1.Put("4","45 Sec")
	map1.Put("5","60 Sec")
	map1.Put("6","75 Sec")
	map1.Put("7","90 Sec")
	Return map1
	
End Sub




Public Sub debugModeSet() As Boolean
  Dim r As Reflector
  debugMode = r.GetStaticField("anywheresoftware.b4a.BA", "debugMode")
  Return debugMode
End Sub
Public Sub debugLog(s As String)
	If debugMode Then Log(s)
End Sub






Public Sub CreatShortcut
	
	Dim PrefMgr As PreferenceManager
    If PrefMgr.GetBoolean("shortcutinstalled") Then
        Return
    End If
    
	Dim packageName As String = "sadLogic.AutoStarts"
	Dim appName As String = "AutoStarts"
	
    Dim shortcutIntent As Intent
    shortcutIntent.Initialize("", "")
    shortcutIntent.SetComponent(packageName & "/.main") ' Put the app package name here
    
    Dim In As Intent
    In.Initialize("", "")
    In.PutExtra("android.intent.extra.shortcut.INTENT", shortcutIntent)
    In.PutExtra("android.intent.extra.shortcut.NAME", appName) ' Put you're application name here
    In.PutExtra("android.intent.extra.shortcut.ICON", LoadBitmap(File.DirAssets, "icon1.png")) ' If you have the icon file in the assets, you just need any bitmap here. Best is 72x72 pixels because launchers do not scale. You might want to experiment a little bit with size
    
    In.Action = "com.android.launcher.action.INSTALL_SHORTCUT"
    
    Dim p As Phone
    p.SendBroadcastIntent(In)
    PrefMgr.SetBoolean("shortcutinstalled", True)


End Sub


