﻿Type=Service
Version=3.82
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	'--- These global variables will be declared once when the application starts.
	'--- These variables can be accessed from all modules.
	
	Private tmrStart As Timer
	
	Private mapApps As Map
	Private xCounter As Int
	
	Private timeDelay As Int = 0
	Private delayBetween As Int = 0
		
	
End Sub
Sub Service_Create

	If File.Exists(File.DirInternal,g.autoStartCheckFile) Then
	
		If File.Exists(g.filepath,g.AppsFile) Then
			mapApps = File.ReadMap(g.filepath,g.AppsFile)
			If mapApps.Size = 0 Then Return '--- no apps defined so exit
		Else
			Return '--- APP's file is missing
		End If
		
		InitVars
		
		tmrStart.Initialize("tmrStart",timeDelay)
		
	End If
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	'--- enabled timer
	If timeDelay <> 0 Then 
		tmrStart.Enabled = True
	End If
End Sub



Private Sub Service_Destroy
End Sub


Private Sub InitVars
		
	Dim mapTime As Map = g.LoadTimeMap
	
	'--- get seconds for timer
	Dim mapTMP As Map = File.ReadMap(g.filepath,g.ConfigFile)
			
	Dim sKey As String
	
	'--- get start up delay
	sKey = mapTMP.Get(c.START_DELAY)
	Dim sTimeDelay As String = mapTime.Get(sKey)
	timeDelay = (Regex.Split(" ",sTimeDelay)(0))
	timeDelay = timeDelay * 1000
	If timeDelay = 0 Then timeDelay = 100 '--- .10ms
	
	'--- delay between starting apps
	sKey = mapTMP.Get(c.DELAY_BETWEEN)
	Dim sDelayBetween As String = mapTime.Get(sKey)
	delayBetween = (Regex.Split(" ",sDelayBetween)(0))
	delayBetween = delayBetween * 1000
	If delayBetween = 0 Then delayBetween = 100 '--- .10ms
	
	
		
End Sub



Private Sub tmrStart_Tick

	tmrStart.Enabled = False '--- turn timer off
	
	'--- get intent of app and run
	Dim it As Intent = g.pm.GetApplicationIntent(mapApps.GetValueAt(xCounter))
	If it.IsInitialized Then StartActivity(it)
	
	'--- do we have more apps to run?
	xCounter = xCounter + 1
	If xCounter < (mapApps.Size) Then
		'--- more apps to run so lets keep going
		tmrStart.Interval = delayBetween
		tmrStart.Enabled = True
	End If
	
End Sub

